--[[
	##AddOn	: SplitItems (On-the-Fly)
	##Subfile	: main.lua
	##Author  : Hati ( xhatix on wowace.com )
--]]
SplitItemsOTF = { }
local SI = SplitItemsOTF
SI.name = 'SplitItemsOnTheFly'
SI.version = function() 
	local r = GetAddOnMetadata( SI.name, 'Version')
	if r == "@project-version" then
		return "SVN-Develop"
	else
		return r
	end
end

SI.ModState = {
	SHIFT = 0,
	ALT = 0,
	CTRL = 0,
}

local function GetIncr()
	local r = 0
	for inc,m in ipairs(SI.db) do
        if m then
            if SI.ModState[m] == 1 then
                r = r + inc*5
            end
        end
	end
	if r == 0 then 
		return 1
	else return r end
end

local function isSplitable(int)
    if int~=1 then
        return true
    end
end

SI.keyCheck = { }
SI.keyCheck.SHIFT = IsShiftKeyDown
SI.keyCheck.CTRL = IsControlKeyDown
SI.keyCheck.ALT = IsAltKeyDown
local function isHalfSplit()
    if SI.keyCheck[SI.db.halfSplit1]() and SI.keyCheck[SI.db.halfSplit2]() then
        return true
    end
end

SI.splitn=nil
function SI:IncreaseSplit(wdir)
	local splitIncr = GetIncr()*wdir
    SI.splitn = (SI.splitn or SI.count)+splitIncr
    if SI.handling=='merchant' then --allow to cancel
        if SI.splitn<0 then
            SI.splitn = SI.count
        elseif SI.splitn>SI.count then
            SI.splitn = 0
        end
    else
        if SI.splitn<1 then
            SI.splitn = SI.count
        elseif SI.splitn>SI.count then
            SI.splitn = 1
        end
    end
    if SI.handling=='personal' or SI.handling=='guild' then
        SI.IsScrolling=true
        ClearCursor()
        SI.IsScrolling=false
    end
    if SI.handling=='personal' then
        SplitContainerItem(SI.bagID,SI.slotID,SI.splitn)
    elseif SI.handling=='guild' then
        SplitGuildBankItem(SI.bagID,SI.slotID,SI.splitn)
    end
    SI.Cursor:SetSplitText(SI.splitn)
end

local function GetScaledCursorPosition(xOffset,yOffset)
	if not xOffset then xOffset=0 end
	if not yOffset then yOffset=0 end
	local scale, x,y = UIParent:GetScale(),GetCursorPosition()
	return (x/scale +xOffset), (y/scale +yOffset)
end

local function SetSplitText(self,int)
    if not int then
        self.text:SetText("")
    elseif int == SI.count then
        if SI.db.HideMax  then
            self.text:SetText("")
        else
            self.text:SetText(int)
        end
    else
        self.text:SetText(int)
    end
end

SI.Cursor = CreateFrame("Frame",SI.name.."_Cursor",UIParent)
SI.Cursor:SetAllPoints(UIParent)
SI.Cursor:SetScript('OnMouseWheel', SI.IncreaseSplit)
SI.Cursor:EnableMouseWheel(0)
SI.Cursor:SetScript('OnUpdate', function(self,elapsed)
	if not self.lastUpdate then self.lastUpdate = 0 end
	self.lastUpdate=self.lastUpdate+elapsed
	while (self.lastUpdate > 0.0334) do
		self.text:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",GetScaledCursorPosition())
		self.lastUpdate = self.lastUpdate - 0.0334
	end
end)
SI.Cursor.text = SI.Cursor:CreateFontString(SI.name.."_FontString","ARTWORK")
SI.Cursor:SetFrameStrata("TOOLTIP")
SI.Cursor.text:SetFont("Fonts\\FRIZQT__.TTF",18,"OUTLINE")
SI.Cursor.text:SetText("")
SI.Cursor.SetSplitText = SetSplitText

--eventFunc
function SI:CURSOR_UPDATE()
	
end

function SI:ADDON_LOADED(addon)
	if addon==SI.name then
		SI:InitDB()
		--SI:RegisterValidEvents()
	end
end



function SI:MODIFIER_STATE_CHANGED(modif, state)
	SI.ModState[string.match(modif,"L?R?(%w+)")] = state
end

function SI:ITEM_LOCK_CHANGED(bagID,slotID)
    local lockStatus
    _,SI.count, lockStatus = GetContainerItemInfo(bagID,slotID)
    if CursorHasItem() and isSplitable(SI.count) and lockStatus then --dropped smth
        self.Cursor:EnableMouseWheel(1)
        --print(bagID,slotID,"picked up")
        self.handling = "personal"
        self.bagID = bagID
        self.slotID = slotID
        --self.splitn = SI.count
        self.Cursor:SetSplitText(SI.count)
    elseif not SI.IsScrolling then
        --print(bagID,slotID,"placed")
        self.Cursor:EnableMouseWheel(0)
        self.Cursor:SetSplitText()
        self.handling=nil
        self.splitn = nil
    end
end

local function GetGuildBankLockedItem()
	local rtab, rslot
	for tab=1,GetNumGuildBankTabs() do
		for slot=1,MAX_GUILDBANK_SLOTS_PER_TAB do
			if select(3,GetGuildBankItemInfo(tab,slot)) then
				rtab=tab
				rslot=slot
				break
			end
		end
	end
	return rtab,rslot
end

local function GB_CursorHasItem()
    if GetCursorInfo()=='item' then
        return true
    end
end

function SI:GUILDBANK_ITEM_LOCK_CHANGED()
    --item picked up in gbank
    local tab,slot = GetGuildBankLockedItem()
    if tab and slot then
        local lockStatus
        _,SI.count,lockStatus = GetGuildBankItemInfo(tab,slot)
        print(tab,slot)
        if GB_CursorHasItem() and isSplitable(SI.count) and lockStatus then
            self.Cursor:EnableMouseWheel(1)
            SI.bagID,SI.slotID = tab,slot
            --SI.splitn = SI.count
            self.handling="guild"
        elseif not SI.IsScrolling then
            self.Cursor:EnableMouseWheel(0)
            self.handling=nil
            self.Cursor:SetSplitText()
        end
    else
        self.Cursor:EnableMouseWheel(0)
        self.Cursor:SetSplitText()
    end
end


SI.eventHandler = { }
SI.eventHandler = CreateFrame("Frame")
SI.eventHandler:RegisterEvent("CURSOR_UPDATE") --items picked up etc.
SI.eventHandler:RegisterEvent("ADDON_LOADED") --dn
SI.eventHandler:RegisterEvent("PLAYER_LOGOUT")
SI.eventHandler:RegisterEvent("ITEM_LOCK_CHANGED") --bank+bags
SI.eventHandler:RegisterEvent("GUILDBANK_ITEM_LOCK_CHANGED")
SI.eventHandler:RegisterEvent("MODIFIER_STATE_CHANGED")
SI.eventHandler:SetScript("OnEvent", function(self, event, ...)
	SI[event](SI,...)
end)


